/****************************************************************************

   This program should be used by registered WWIV sysops with modified
   userrecords.  Compile this with your modified vardec.h, and run it
   in your from the same directory where CBV is run from,  this can later
   be used to auto-enter the values needed in CBVCFG.

   This program (AUTOCFG.C) may be freely distributed.

   !!!IF YOU HAVE SOURCE TO WWIV AND HAVE NOT REGISTERED PLEASE DO SO!!!

 ****************************************************************************/


#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include "vardec.h"

typedef struct {
          userreclen,                   /* length of userrec    */
          offset_name,                  /* offset to name       */
          offset_phone,                 /* offset to phone      */
          offset_passwd,                /* offset to passwd     */
          offset_note,                  /* offset to note       */
          offset_sl,                    /* offset to sl         */
          offset_dsl,                   /* offset to dsl        */
          offset_exempt,                /* offset to exempt     */
          offset_ar,                    /* offset to ar         */
          offset_dar,                   /* offset to dar        */
          offset_rest;                  /* offset to restrict   */
        } autocfgrec;


int         autocfgfile;                /* autoconfig file              */
userrec     *user;                      /* pointer to userrec structure */
autocfgrec  autocfg;                    /* convienent handle for this   */

void main()
  {

    printf("This program,  autocfg,  will create a BINARY file called AUTOCFG.CBV.\n");
    printf("This file can be loaded from within CBVCFG to auto-enter the values\n");
    printf("needed for sysops who have modified the structure of their userrecs.\n\n");
    printf("It could also be used for those sysops who just want to take that extra\n");
    printf("step to guarantee that the values used by CBV are correct.\n\n");
    printf("Compile (with your current vardec.h file),  and run this program from\n");
    printf("the same directory where CBV is located.\n\n");
    printf("If you have the source to WWIV and have not registered please do so!\n\n");

    autocfg.userreclen     = sizeof(userrec);
    autocfg.offset_name    = FP_OFF(&(user->name))      - FP_OFF(user->name);
    autocfg.offset_phone   = FP_OFF(&(user->phone))     - FP_OFF(user->name);
    autocfg.offset_passwd  = FP_OFF(&(user->pw))        - FP_OFF(user->name);
    autocfg.offset_note    = FP_OFF(&(user->note))      - FP_OFF(user->name);
    autocfg.offset_sl      = FP_OFF(&(user->sl))        - FP_OFF(user->name);
    autocfg.offset_dsl     = FP_OFF(&(user->dsl))       - FP_OFF(user->name);
    autocfg.offset_exempt  = FP_OFF(&(user->exempt))    - FP_OFF(user->name);
    autocfg.offset_ar      = FP_OFF(&(user->ar))        - FP_OFF(user->name);
    autocfg.offset_dar     = FP_OFF(&(user->dar))       - FP_OFF(user->name);
    autocfg.offset_rest    = FP_OFF(&(user->restrict))  - FP_OFF(user->name);

		autocfgfile = open("AUTOCFG.CBV",O_RDWR | O_CREAT | O_BINARY | O_TRUNC);
		write(autocfgfile, (void *) (&autocfg), sizeof(autocfgrec));
    close(autocfgfile);
    printf("File AUTOCFG.CBV written to disk \n\n");
  }


